using System;
using Unit4.CollectionsLib;
using Unit4.UtilsLib;
using System.Text;

namespace ConsoleApplicationMergeLists1
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Build two sorted Lists");
            List<double> list1 = new List<double>();
            List<double> list2 = new List<double>();
            int i;
            Node<double> pos = list1.GetFirst();
            for (i = 50; i < 80; i += 3)
            {
                pos = list1.Insert(pos, i);
            }
            pos = list2.GetFirst();
            for (i = 62; i < 100; i += 3)
            {
                pos = list2.Insert(pos, i);
            }
            Console.WriteLine(list1);
            Console.WriteLine(list2);
            Console.WriteLine("-----------------------------------------------");
            Console.WriteLine("Two sorted Lists Merge to one");
            Console.WriteLine(MergeLists(list2, list1));
            Console.WriteLine("-----------------------------------------------");
            Console.WriteLine("Two sorted Lists Merge to one width temp Map");
            Console.WriteLine(MergeListsWidthMap(list1, list2));
            Console.ReadLine();
        }
        //       
        public static List<double> MergeLists(List<double> list1, List<double> list2)
        {
            Node<double> pos1 = list1.GetFirst();
            Node<double> pos2 = list2.GetFirst();
            Node<double> pos3 = null;

            List<double> list3 = new List<double>();
            double info1, info2, small;
            while (pos1 != null && pos2 != null)
            {
                info1 = pos1.GetInfo();
                info2 = pos2.GetInfo();
                if (info1 < info2)
                {
                    small = info1;
                    pos1 = pos1.GetNext();
                }
                else
                    if (info1 > info2)
                    {
                        small = info2;
                        pos2 = pos2.GetNext();
                    }
                    else
                    {
                        small = info1;
                        pos1 = pos1.GetNext();
                        pos2 = pos2.GetNext();
                    }
                pos3 = list3.Insert(pos3, small);
            }

            while (pos1 != null)
            {
                pos3 = list3.Insert(pos3, pos1.GetInfo());
                pos1 = pos1.GetNext();
            }

            while (pos2 != null)
            {
                pos3 = list3.Insert(pos3, pos2.GetInfo());
                pos2 = pos2.GetNext();
            }

            return (list3);
        }
        public static List<double> MergeListsWidthMap(List<double> list1, List<double> list2)
        {
            Map<double> m = new Map<double>();
            Node<double> pos1 = list1.GetFirst();
            Node<double> pos2 = list2.GetFirst();
            String []keys;
            while (pos1 != null)
            {
                m.Insert(pos1.GetInfo().ToString(), pos1.GetInfo());
                pos1 = pos1.GetNext();
            }
            while (pos2 != null)
            {
                m.Insert(pos2.GetInfo().ToString(), pos2.GetInfo());
                pos2 = pos2.GetNext();
            }
            keys = m.GetAllKeys();
            List<double> list3 = new List<double>();
            Node<double> pos3 = null;
            for (int i = 0; i < keys.Length; i++)
            {
                pos3 = list3.Insert(pos3, double.Parse(keys[i]));
            }
            return list3;
        }
    }
}
